#include<stdio.h>
#include<X11/Xlib.h>

#include"xyag.h"

#define MAX_NODE 1024       /* ֥κ */

static XPoint Point[1024];  /* ԽΥ֥Ȥκɸ */
static int Num_node;        /* ԽΥ֥Ȥο   */

static obj_t  *Cur_obj;     /* ڡκǽ֥ */

static int Sx,Sy;           /* νüɸ         */
static int Xor_state = 0;   /* ɽƤ뤫 */


/* ä */

void del_xor( void )
{
  if( Xor_state == 0 )
    return;

  XDrawLine( Disp,Scr_p,Gc_xor,
	    Point[Num_node-1].x,Point[Num_node-1].y,Sx,Sy );

  XDrawLine( Disp,Scr_w,Gc_xor,
	    Point[Num_node-1].x,Point[Num_node-1].y,Sx,Sy );

  Xor_state = 0;
}


/*  */

void draw_xor( int x, int y )
{
  if( Xor_state )
    del_xor();

  XDrawLine( Disp,Scr_p,Gc_xor,Point[Num_node-1].x,Point[Num_node-1].y,x,y );
  XDrawLine( Disp,Scr_w,Gc_xor,Point[Num_node-1].x,Point[Num_node-1].y,x,y );

  Sx = x;
  Sy = y;
  Xor_state = 1;
}


/* ֥Խ */

void set_point( int x, int y )
{
  Num_node = 1;
  Point[0].x = x;
  Point[0].y = y;
}


/* ֥Ȥηͳλ */

void next_point( int x, int y )
{
  if( Num_node == 1024 )
    return;

  del_xor();

  Point[Num_node].x = x;
  Point[Num_node].y = y;

  Gc = Gc_fg;
  XDrawLine(Disp,Scr_p,Gc,Point[Num_node-1].x,Point[Num_node-1].y,x,y );
  XDrawLine(Disp,Scr_w,Gc,Point[Num_node-1].x,Point[Num_node-1].y,x,y );

  Num_node++;
}


/* ֥Ȥξõʼ¹ԸΥ⡼ɤ֤ */

int prev_point( void )
{
  del_xor();

  if( Num_node == 1 )
    return 0;

  Num_node--;


  XDrawLine( Disp,Scr_p,Gc_bg,
	    Point[Num_node-1].x,Point[Num_node-1].y,
	    Point[Num_node].x,Point[Num_node].y );

  XDrawLine( Disp,Scr_w,Gc_bg,
	    Point[Num_node-1].x,Point[Num_node-1].y,
	    Point[Num_node].x,Point[Num_node].y );

  Option.changed = True;
  return 1;
}


/* ֥Ȥν */

void cut_point( void )
{
  obj_t *p;
  XPoint *q;

  q = (XPoint*)XtCalloc( Num_node,sizeof(XPoint) );

  p = (obj_t*)XtMalloc( sizeof(obj_t) );

  del_xor();

  Cur_obj->next = p;
  p->prev = Cur_obj;
  p->next = NULL;

  bcopy( Point,q,sizeof(XPoint) * Num_node );
  p->data = q;
  p->length = Num_node;

  Cur_obj = p;

  Option.changed = True;
}


/* ֥Ⱦõ */

void del_obj( void )
{
  obj_t *p;

  if( Cur_obj == &Cur_page->data_head )
    return;

  p = Cur_obj;
  Cur_obj = Cur_obj->prev;
  Cur_obj->next = NULL;
  free( p );

  Option.changed = True;
  change_page();
}


/* ڡؤ */

void change_page( void )
{
  clear_scr();
  Xor_state = 0;

  if( Option.see_next && Cur_page->next != NULL ){
    Gc = Gc_next;
    draw_page( Cur_page->next );
  }

  if( Option.see_prev && Cur_page->prev != &Head_page ){
    Gc = Gc_prev;
    draw_page( Cur_page->prev );
  }

  Gc = Gc_fg;
  draw_page( Cur_page );

  flush_scr();

  Cur_obj = &Cur_page->data_head;

  while( Cur_obj->next != NULL )
    Cur_obj = Cur_obj->next;

  number_page();
}


/* ֥Ⱦõ */

void clear_page( void )
{
  obj_t *p,*q;

  p = Cur_page->data_head.next;
  while( p != NULL ){
    free( p->data );
    q = p;
    p = p->next;
    free( q );
  }
  Cur_page->data_head.next = NULL;
  change_page();
  Option.changed = True;
}  


/* ڡõ */

void del_page( void )
{
  page_t *r;

  clear_page();

  if( Cur_page->prev != Cur_page->next ){
    r = Cur_page;

    Cur_page->prev->next = Cur_page->next;
    Cur_page->next->prev = Cur_page->prev;

    if( Cur_page->next != &Head_page )
      Cur_page = Cur_page->next;
    else{
      Cur_page = Cur_page->prev;
      Option.page--;
    }

    free( r );

    Option.page_max--;
    change_page();
    Option.changed = True;
  }else
    Option.changed = False;
}


/* ڡɲáʥȥڡɲá */

void ins_page(void )
{
  page_t *p;

  p = (page_t*)XtMalloc( sizeof(page_t) );

  p->data_head.next = NULL;

  p->prev = Cur_page->prev;
  p->next = Cur_page;
  Cur_page->prev->next = p;
  Cur_page->prev = p;

  Cur_page = p;

  Option.page_max++;
  change_page();

  Option.changed = True;
}


/* ڡɲáʥȥڡθɲá */

void add_page( void )
{
  page_t *p;

  p = (page_t*)XtMalloc( sizeof(page_t) );

  p->data_head.next = NULL;

  p->next = Cur_page->next;
  p->prev = Cur_page;
  Cur_page->next->prev = p;
  Cur_page->next = p;

  Cur_page = p;

  Option.page++;
  Option.page_max++;

  change_page();

  Option.changed = True;
}


/* ڡ */

void prev_page( void )
{
  if( Cur_page->prev != &Head_page ){
    Cur_page = Cur_page->prev;
    Option.page--;
    change_page();
  }
}


/* ڡ */

void next_page( void )
{
  if( Cur_page->next != &Head_page ){
    Cur_page = Cur_page->next;
    Option.page++;
    change_page();
  }
}


/*  */

void init_page( void )
{
  page_t *p;

  p = (page_t*)XtMalloc( sizeof(page_t) );

  Head_page.next = p;
  Head_page.prev = p;

  Cur_page = p;
  Cur_page->prev = &Head_page;
  Cur_page->next = &Head_page;
  Cur_page->data_head.next = NULL;
  Cur_page->data_head.prev = NULL;

  Option.page = 1;
  Option.page_max = 1;
  Option.changed = False;

  change_page();
}
